db $42
JMP return : JMP return : JMP return : JMP return : JMP return : JMP return : JMP return : JMP return : JMP main : JMP return 

!freeram	=	$0058		;\must be 4 digits
!freeram_timer	=	$005C		;/
!sound		=	$0D		;>sound bank $1DF9 (when mario starts spinning)
!timer		=	$78		;\how long will mario will warp, each 60 (3C in hex) is a second
					;/because it runs 60 frames per second.

main:
	LDA $16			;\
	AND #$08		;|if mario enters the teleporter pad properly
	BEQ return		;|
	LDA $1470		;|
	BNE return		;|
	LDA $72			;|
	BNE return		;|
	LDA $187A		;|
	BNE return		;/
	LDA !freeram		;\if teleporter flag is already set...
	BNE return		;/then return
	STZ $7B			;>cancel mario's x speed
	LDA #!sound		;\play sound
	STA $1DF9		;/
	STZ $9D			;\so mario can't get harm when he use the pad and gets hit simultaneously
	LDA #$01		;|
	STA $1497		;/
	INC !freeram		;>set flag
	LDA #!timer		;\set timer flag
	STA !freeram_timer	;/

;this will center the player, so when mario is warping, he wouldn't be a bit off
;from the block's position. It also fixes the glitch that triggers the previous
;screen boundry (in horizontal levels) when placed on the edge of the screen
;boundry on the right side when entered slightly to the left from the block.
	LDA $93
	BEQ rightside	
	BRA leftside
rightside:
	LDA $94
	AND #$F0
	STA $94
	BRA return
leftside:
	LDA $94
	AND #$F0
	CLC : ADC #$10
	STA $94
	LDA $95
	ADC #$00
	STA $95
return:
	RTL
	
