;put this in gamemode_init_code.asm (it actually runs the main) or level_code.asm
	!freeram	 = $0058	;\must be 4 digits
	!freeram_timer   = $005C	;/
	!sound		 = $10		;\sound bank $1DF9 (a sound that play right when
					;/mario "disappear" from level)
	!speed		 = $3F		;>choose 00-7F


	LDA $0100		;>game mode
	CMP #$14		;>if mode is level
	BEQ skip_reset_flags	;>then skip
	STZ !freeram		;\otherwise reset flags and timers when re-enter
	STZ !freeram_timer	;/level or to another level
skip_reset_flags:
	LDA !freeram		;\if the exit pad isn't set
	BEQ end			;/then don't do anything
	STZ $7B			;>cancel mario's x speed
	STZ $15			;\
	STZ $16			;|freeze the player and disable
	STZ $17			;|controls
	STZ $18			;/
	LDA #$01		;\make mario spin
	STA $140D		;/
	LDA #$01		;\make mario invulnerable and don't interact with foes
	STA $1497		;/
	LDA #$01		;\lose interaction with layer 1
	STA $185C		;/
	STZ $1412		;\lock screen
	STZ $1411		;/
	STZ $9D			;>used if player takes damage at the same time he uses the block
	LDA #!speed		;>if user put a number thats negative (80-FF upward speed)
	BMI skip_flip		;then don't convert number
	EOR #$FF		;otherwise flip so its negative and still goes up
skip_flip:			;>then skip the flip value
	STA $7D			;>set speed
	LDA $9D			;\if freeze is happening
	BNE end			;/then stop timer
	LDA !freeram_timer	;\if timer is 0
	BEQ check_warp_flag	;/then check warp flag
	DEC !freeram_timer
	BRA end
check_warp_flag:
	LDA !freeram
	BEQ end

	LDA #$06				;\warp player (note, you can replace this code
	STA $71					;|with a different code with different effects,
	STZ $88					;|like take mario to a different OW map position
	STZ $89					;/instead of exiting to another level).

	LDA #!sound				;\play sound
	STA $1DF9				;/
	STZ !freeram
	STZ !freeram_timer
end:
	RTS